protected/models/User.php
<?php

/**
 * This is the model class for table "user".
 *
 * The followings are the available columns in table 'user':
 * @property integer $id_user
 * @property string $name
 * @property string $description
 * @property integer $salt
 * @property string $password
 * @property integer $id_role
 * @property string $email
 *
 * The followings are the available model relations:
 * @property Comment[] $comments
 * @property Edit[] $edits
 * @property Ticket[] $tickets
 * @property UserRole $role
 */
class User extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return User the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'user';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('name, description, salt, password, id_role, email', 'required'),
			array('salt, id_role', 'numerical', 'integerOnly'=>true),
			array('name', 'length', 'max'=>32),
			array('description', 'length', 'max'=>45),
			array('password', 'length', 'max'=>20),
			array('email', 'length', 'max'=>128),
            array('email','email'),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('id_user, name, description, salt, password, id_role, email', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
			'comments' => array(self::HAS_MANY, 'Comment', 'id_author'),
			'edits' => array(self::HAS_MANY, 'Edit', 'id_user'),
			'tickets' => array(self::HAS_MANY, 'Ticket', 'id_assignee'),
			'role' => array(self::BELONGS_TO, 'UserRole', 'id_role'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id_user' => 'Id User',
			'name' => 'Name',
			'description' => 'Description',
			'salt' => 'Salt',
			'password' => 'Password',
			'id_role' => 'Id Role',
			'email' => 'Email',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id_user',$this->id_user);
		$criteria->compare('name',$this->name,true);
		$criteria->compare('description',$this->description,true);
		$criteria->compare('salt',$this->salt);
		$criteria->compare('password',$this->password,true);
		$criteria->compare('id_role',$this->id_role);
		$criteria->compare('email',$this->email,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
    
    function valid_password ( $pass )
    {
        return sha1($pass.$this->salt) == $this->password;
    }
    
    function can_login()
    {
        return $this->id_role != 4;
    }
    
    function avatar_url($size=32)
    {
        return "http://www.gravatar.com/avatar/" .
            md5( strtolower( trim( $this->email ) ) ) .
            "?s=" . $size;
    }
    
    function avatar_image($size=32,$htmlOptions=array())
    {
        $htmlOptions['width'] = $size;
        $htmlOptions['height'] = $size;
        return CHtml::image($this->avatar_url(),''/*$this->name*/,$htmlOptions);
    }
    
    function url()
    {
        return array('user/view','name'=>$this->name);
    }
    
    function link()
    {
        return CHtml::link($this->name,$this->url());
    }
    
    
}

protected/controllers/MainController.php
<?php

class MainController extends Controller
{
	public function actionIndex()
	{
        $this->redirect(array('page/index'));
	}

	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
        $this->renderError();
	}

    function getPageTitle()
    {
        if ( isset($this->page_title) )
            return $this->page_title;
        
        return Yii::app()->name ." | ". ucfirst($this->action->id);
    }
    
    function actionCss($sheet)
    {
        header('Content-Type: text/css');
        $this->renderPartial('/css/'.$sheet); // todo: check minification performance
        //echo CssMin::minify($this->renderPartial('/css/'.$sheet,null,true));
    }
    
    
    function actionSearch()
    {
        $this->set_return_url($_REQUEST);
        $search = new SearchForm;
        if ( isset($_GET['q']) )
            $search->term = $_GET['q'];
        if ( isset($_REQUEST['SearchForm']) )
            $search->attributes = $_REQUEST['SearchForm'];
        $this->render('search',array('search'=>$search));
    }
    
    function actionTest()
    {
        $this->render('test');
    }
}

protected/controllers/UserController.php
<?php

class UserController extends Controller
{
    

	/**
	 * Displays the login page
	 */
	public function actionLogin()
	{
		$model=new LoginForm;

		// if it is ajax validation request
		if(isset($_POST['ajax']) && $_POST['ajax']==='login-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}

		// collect user input data
		if(isset($_POST['LoginForm']))
		{
			$model->attributes=$_POST['LoginForm'];
			// validate user input and redirect to the previous page if valid
			if($model->validate() && $model->login())
				$this->redirect(Yii::app()->user->returnUrl);
		}
		// display the login form
		$this->render('login',array('model'=>$model));
	}

	/**
	 * Logs out the current user and redirect to homepage.
	 */
	public function actionLogout()
	{
		Yii::app()->user->logout();
        if ( Yii::app()->request->urlReferrer == null ||
            Yii::app()->request->urlReferrer == Yii::app()->request->url )
            $this->redirect(Yii::app()->homeUrl);
        else
            $this->redirect( Yii::app()->request->urlReferrer );
	}
    
    function actionView($name)
    {
        $this->set_return_url();
        $user = User::model()->findByAttributes(array('name'=>$name));
        if ( $user == null )
            throw new CHttpException(404,"No user called '$name' was found");
        $this->render('user',array('user'=>$user));
    }
    
}

protected/views/user/login.php
<?php
/* @var $this SiteController */
/* @var $model LoginForm */
/* @var $form CustomForm  */

$this->pageTitle = "Log In | ".Yii::app()->name;

?>

<h2 class="title">Login</h2>

<div class="login">
<?php

$form=$this->beginWidget('CustomForm', array(
	'id'=>'login-form',
    'model'=>$model
)); 

    echo $form->autoTextRow('username');
    echo $form->autoPasswordRow('password');
    echo $form->autoCheckBoxRow('rememberMe');
    

	echo '<div class="row buttons">'.
            CHtml::submitButton('Log In').
        '</div>';

$this->endWidget(); ?>

<p>Can't log in?</p>
<ul class="tml-action-links">
    <li>
    <a rel="nofollow" href="<?php
        echo $this->base_url();?>/register">Register</a>
    </li>
    <li>
        <a rel="nofollow" href="<?php
            echo $this->base_url();?>/lostPassword">Recover Lost Password</a>
    </li>
</ul>

</div><!-- form -->

protected/views/user/user.php
<?php

$this->pageTitle = Yii::app()->name." | User |".$user->name;

$this->link_actions=array(
    array('label'=>'Content by '.$user->name,
        'url' => array('main/search','SearchForm[username]'=>$user->name)
    )
);

echo '<h2 class="title">'.CHtml::encode($user->name).'</h2>';

echo '<p>'.CHtml::encode($user->role->name).'</p>';
echo '<div class="user">';
echo '<img alt="" src="'.$user->avatar_url(128).'" class="avatar-large" />';
echo CHtml::encode($user->description);
echo '</div>';

if ( $user->role->has_role('contributor') )
{
    echo '<h3 class="title">Active tasks</h3>';
    
    
    $tick=new Ticket('search');
    $tick->unsetAttributes();  // clear any default values
    if(isset($_GET['Ticket']))
        $tick->attributes=$_GET['Ticket'];
        
    $dp = $tick->search();
    
    $dp->criteria->addSearchCondition('id_assignee',$user->id_user);
    $dp->criteria->addNotInCondition('status.name',array('wontfix','closed'));

    $this->widget('DynamicPageGridView', array(
    'id'=>'ticket-grid',
    'dataProvider'=>$dp,
    'filter'=>$tick,
    'cssFile'=>CHtml::normalizeUrl(array('main/css','sheet'=>'gridview')),
    'columns'=>array(
        array(
            'class' => 'CDataColumn',
            'name' => 'searchTitle',
            'type'=>'html',
            'value' => 'CHtml::link($data->post->title,
                                    array("ticket/view","id"=>$data->id_ticket))',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'searchProject',
            'type'=>'html',
            'filter'=>CustomForm::drop_down('Project','id_project'),
            'value'=>'CHtml::link($data->version->project->name,
                    array("ticket/project","id"=>$data->version->id_project))',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_type',
            'filter'=>CustomForm::drop_down('TicketType','id_ticket_type'),
            'value'=>'$data->type->name',
            'cssClassExpression'=>'"ticket-".$data->type->name',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_priority',
            'filter'=>CustomForm::drop_down('TicketPriority','id_ticket_priority'),
            'value'=>'$data->priority->name',
            'cssClassExpression'=>'"ticket-".$data->priority->name',
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_status',
            'filter'=>CustomForm::drop_down('TicketStatus','id_ticket_status'),
            'value'=>'$data->status->name',
            'cssClassExpression'=>'"ticket-".$data->status->name',
        ),
    ),
));
}


$post=new Post('search');
$post->unsetAttributes();  // clear any default values
if(isset($_GET['Post']))
    $post->attributes=$_GET['Post'];
    
echo '<h3 class="title">Content by this user</h3>';
$this->widget('DynamicPageGridView', array(
    'id'=>'search-grid',
    'cssFile'=>CHtml::normalizeUrl(array('main/css','sheet'=>'gridview')),
    'dataProvider'=>$post->search_by_user($user),
    'filter' => $post,
    'get_param' => 'npost',
    'page_sizes' => array(8,20,50,100,'infinity'),
    'page_size' => 8,
    'columns' => array(
        array(
            'name'=>'title',
            'type'=>'html',
            'value'=>'$data->link()'
        ),
        array(
            'class'=>'CDataColumn',
            'name'=>'id_type',
            'header'=>'Type',
            'filter'=>CustomForm::drop_down('PostType','id_post_type'),
            'value'=>'$data->type->name',
        ),
        'content.date'
    )
));